//+----------------------------------------------------------------------+
//|ZigZag    Ensign (v7)                            |
//|----------------------------------------------------------------------+
//|                                                                      |
//|                                                    |
//|minBars -   (  )                  |
//|minSize -     (  )  |
//|                                                                      |
//|                                                     |
//|minBars2 -   (  )                 |
//|minSize2 -     (  ) |
//|                                                                      |
//+----------------------------------------------------------------------+
#property copyright "nen"
#property link      "http://onix-trade.net/forum/index.php?s=&showtopic=118&view=findpost&p=169603"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow
//---- indicator parameters
extern int minBars  = 0;
extern int minSize  = 50;
extern int minBars2 = 5;
extern int minSize2 = 25;
//-------------------------------------

//   ZigZag 
//    ZigZag
double zz[];

//   ZigZag    Ensign
double si,di,di2,lLast=0,hLast=0;
int fs,countBar,countBar2;
int ai,bi,ai0,bi0;
datetime tai,tbi,ti;
bool fh=false,fl=false,fcount0,fcount02;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(1);
//---- drawing settings
// ZigZag
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexBuffer(0,zz);
   SetIndexEmptyValue(0,0.0);
   if (minBars2<minBars) minBars2=minBars;
   if (minSize2>minSize) minSize2=minSize;
   if (minSize!=0) {di=minSize*Point; countBar=minBars;}
   if (minSize2!=0) {di2=minSize2*Point; countBar2=minBars2;}

   return(0);
  }
//+------------------------------------------------------------------+
//| .       
//+------------------------------------------------------------------+
int deinit() 
  {
   return(0);
  }
//********************************************************
// 
int start()
  {

   int i,n,cbi;
   
   cbi=Bars-IndicatorCounted()-1;
//---------------------------------
   for (i=cbi; i>=0; i--) 
     {
//-------------------------------------------------
      //       
      if (hLast==0) {lLast=Low[i];hLast=High[i];}

      //        .
      //         .
      if (fs==0)
        {
         if (lLast<Low[i] && hLast<High[i]) {fs=1; hLast=High[i]; si=High[i]; ai=i; tai=Time[i];}  //  
         if (lLast>Low[i] && hLast>High[i]) {fs=2; lLast=Low[i]; si=Low[i]; bi=i; tbi=Time[i];}  //  
        }

      if (ti!=Time[i])
        {
         //     fs   
         ti=Time[i];

         ai0=iBarShift(Symbol(),Period(),tai); 
         bi0=iBarShift(Symbol(),Period(),tbi);

         fcount0=false; fcount02=false;
         if ((fh || fl) && countBar>0) {countBar--; if (i==0 && countBar<=0) fcount0=true;}
         if ((fh || fl) && countBar2>0) {countBar2--; if (i==0 && countBar2<=0) fcount02=true;}
          
         // .    .
         if (fs==1)
           {
            if (hLast>High[i] && !fh) fh=true;

            if (i==0)
              {
               if (Close[i+1]<lLast && fh) {fs=2; countBar=minBars; countBar2=minBars2; fh=false;}
               if ((countBar==0 && si-di>Low[i+1] && High[i+1]<hLast && ai0>i+1 && fh && !fcount0) || (countBar2==0 && si-di2>Low[i+1] && High[i+1]<hLast && ai0>i+1 && fh && !fcount02))
                 {fs=2; countBar=minBars; countBar2=minBars2; fh=false;}

               if (fs==2) //         
                 {
                  zz[ai0]=High[ai0];
                  lLast=Low[i+1];
                  si=Low[i+1];
                  bi=i+1;
                  tbi=Time[i+1];
                }
              }
             else
              {
               if (Close[i]<lLast && fh) {fs=2; countBar=minBars; countBar2=minBars2; fh=false;}
               if ((countBar==0 && si-di>Low[i] && High[i]<hLast && fh) || (countBar2==0 && si-di2>Low[i] && High[i]<hLast && fh))
                 {fs=2; countBar=minBars; countBar2=minBars2; fh=false;}

               if (fs==2) //      
                 {
                  zz[ai]=High[ai];
                  lLast=Low[i];
                  si=Low[i];
                  bi=i;
                  tbi=Time[i];
                 }
              }
           }
         else // fs==2
           {
            if (lLast<Low[i] && !fl) fl=true;

            if (i==0)
              {
               if (Close[i+1]>hLast && fl) {fs=1; countBar=minBars; countBar2=minBars2; fl=false;}
               if ((countBar==0 && si+di<High[i+1] && Low[i+1]>lLast && bi0>i+1 && fl && !fcount0) || (countBar2==0 && si+di2<High[i+1] && Low[i+1]>lLast && bi0>i+1 && fl && !fcount02))
                 {fs=1; countBar=minBars; countBar2=minBars2; fl=false;}

               if (fs==1) //         
                 {
                  zz[bi0]=Low[bi0];
                  hLast=High[i+1];
                  si=High[i+1];
                  ai=i+1;
                  tai=Time[i+1];
                 }
              }
             else
              {
               if (Close[i]>hLast && fl) {fs=1; countBar=minBars; countBar2=minBars2; fl=false;}
               if ((countBar==0 && si+di<High[i] && Low[i]>lLast && fl) || (countBar2==0 && si+di2<High[i] && Low[i]>lLast && fl))
                 {fs=1; countBar=minBars; countBar2=minBars2; fl=false;}

               if (fs==1) //      
                 {
                  zz[bi]=Low[bi];
                  hLast=High[i];
                  si=High[i];
                  ai=i;
                  tai=Time[i];
                 }
              }
           }
        } 

      //  
      if (fs==1 && High[i]>si) {ai=i; tai=Time[i]; hLast=High[i]; si=High[i]; countBar=minBars; countBar2=minBars2; fh=false;}
      if (fs==2 && Low[i]<si) {bi=i; tbi=Time[i]; lLast=Low[i]; si=Low[i]; countBar=minBars; countBar2=minBars2; fl=false;}

//===================================================================================================
      //  .    ZigZag-a

      if (i==0) 
        {
         ai0=iBarShift(Symbol(),Period(),tai); 
         bi0=iBarShift(Symbol(),Period(),tbi);

         if (fs==1) { for (n=bi0-1; n>0; n--) {zz[n]=0;} zz[ai0]=High[ai0];}         
         if (fs==2) {for (n=ai0-1; n>0; n--) {zz[n]=0;} zz[bi0]=Low[bi0];}
        }

//====================================================================================================
     }
//--------------------------------------------
  }